%Script pentru aplicatia A1

clear all;

t=-0.1:0.001:0.1;  % varibila timp 
x=zeros(1,length(t));
T=0.1;
W=2*pi/T;

% Dezvoltarea in serie Fourier a semnalului x(t)
for n=[-2000:-1 1:2000]
    x=x+sin(n*pi/2)/(n*pi)*exp(1j*n*W*t);
end
x=x+0.5; % componenta de curent continuu

%afisare x
subplot(3,1,1);
plot(t,x);grid on;
title('Semnalul nefiltrat');

K=1.5*10^(-2);

% Dezvoltarea in serie Fourier a raspunsului 
y1=zeros(1,length(t));
%faza(n)=zeros(1,length(t));
for n=[-2000:-1 1:2000]
    faza=exp(-1j*atan(n*W*K));  %faza filtrului !!!
    y1=y1+sin(n*pi/2)/(n*pi)*exp(1j*n*W*t)*faza;  %*1/sqrt((n*W*K)^2+1)
end
y1=y1+0.5;


%afisare y1
subplot(3,1,2);
plot(t,y1);grid on;
xlabel('timp');
ylabel('amplitudine');
title('Semnalul filtrat cu FTT a carui faza este neliniara');

% Sa se inlocuiasca in dezvoltarea in serii Fourier a semnalului y1 faza
% introdusa se filtru ( -atan(w*K) ) cu faza liniara -w*K

y2=zeros(1,length(t));
%faza(n)=zeros(1,length(t));
for n=[-2000:-1 1:2000]
    faza=exp(1j*(-n*W*K+0)); %
    y2=y2+sin(n*pi/2)/(n*pi)*exp(1j*n*W*t)*faza;  %*1/sqrt((n*W*K)^2+1)
end
y2=y2+0.5;

% afisare y2
subplot(3,1,3);
plot(t,abs(y2));grid on;
xlabel('timp');
ylabel('amplitudine');
title('Semnalul nefiltrat');
title('Semnalul filtrat cu FTT a carui faza este liniara');